#ifndef STRCONVS_INCLUDED
#define STRCONVS_INCLUDED



#ifndef TYPES_INCLUDED
    #error "Needs types(Types.inc)."
    //#include "Types.inc"
#endif

//TCPUTime to str

//TIBeam to str

void DatumToStr(const TDatum &Datum, char Buf[])
{
    PDL("void DatumToStr(const TDatum & Datum, char Buf[]): Builds a string from one data point. The buffer should be preloaded with a prefix, or just a null.");
    I16 SI = strlen(Buf);
    U8 B;
    ForInt(ByteI, 0, 5)
        B = Datum.X[ByteI];
        ForInt(BitI, 0, 7)
            Buf[SI++] = '0' + (B & 1);
            B >>= 1;
        EndFor;
        Buf[SI++] = ' ';
    EndFor;
    ForInt(ByteI, 0, 5)
        B = Datum.Y[ByteI];
        ForInt(BitI, 0, 7)
            Buf[SI++] = '0' + (B & 1);
            B >>= 1;
        EndFor;
        Buf[SI++] = ' ';
    EndFor;
    if ( DIO96Base[1] )
    {
        ForInt(ByteI, 0, 5)
            B = Datum.LX[ByteI];
            ForInt(BitI, 0, 7)
                Buf[SI++] = '0' + (B & 1);
                B >>= 1;
            EndFor;
            Buf[SI++] = ' ';
        EndFor;
    }
    Buf[--SI] = 0;
}

//Theoretically TCounters to str, but why?


char *itod(I32 i)
{
//    PDL("char *itod(I32 i): converts an int to a decimal-radix ASCII string and returns a pointer to that string.");
    TBool bNeg;
    static char sbuf[sizeof(i) * 3 + 2];
    char * pBuf = sbuf + sizeof(sbuf);
    *--pBuf = '\0';

    #pragma warn -pia
    if ( bNeg = TBool(i < 0) ) i = -i;
    #pragma warn +pia

    do
    {
        *--pBuf = '0' + (i % 10);
        i /= 10;
    } while ( i );

    if ( bNeg ) *--pBuf = '-';
    return pBuf;
}

char *utod(U32 i)
{
    //PDL("char *utod(U32 i): converts a U32 to a decimal-radix ASCII string and returns a pointer to that string.");
    static char sbuf[sizeof(i) * 3 + 2];
    char * pBuf = sbuf + sizeof(sbuf);
    *--pBuf = '\0';

    do
    {
        *--pBuf = '0' + (i % 10);
        i /= 10;
    } while ( i );

    return pBuf;
}



#endif